package com.ibm.etools.gef.examples.shapes.edit;

import com.ibm.etools.common.command.Command;
import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.geometry.Point;
import com.ibm.etools.draw2d.geometry.Rectangle;
import com.ibm.etools.gef.EditPart;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.gef.Request;
import com.ibm.etools.gef.editpolicies.ResizableEditPolicy;
import com.ibm.etools.gef.editpolicies.XYLayoutEditPolicy;
import com.ibm.etools.gef.examples.shapes.model.*;
import com.ibm.etools.gef.examples.shapes.model.Shape;
import com.ibm.etools.gef.requests.CreateRequest;

public class ShapeXYLayoutEditPolicy extends XYLayoutEditPolicy {

protected Command createAddCommand(EditPart childEditPart, Object constraint) {
	Shape shape = (Shape)childEditPart.getModel();
	Rectangle rect = (Rectangle)constraint;

	AddCommand add = new AddCommand();
	add.setParent((ShapeDiagram)getHost().getModel());
	add.setChild(shape);
	add.setLabel("Add");  //$NON-NLS-1$

	SetConstraintCommand setConstraint = new SetConstraintCommand();

	setConstraint.setLocation(rect);
	setConstraint.setPart(shape);
	setConstraint.setLabel("Add"); //$NON-NLS-1$
	return add.chain(setConstraint);
}

protected Command createChangeConstraintCommand(EditPart child, Object constraint) {
	SetConstraintCommand locationCommand = new SetConstraintCommand();
	locationCommand.setPart((Shape)child.getModel());
	locationCommand.setLocation((Rectangle)constraint);
	return locationCommand;
}

protected Command getCreateCommand(CreateRequest request) {
	CreateCommand create = new CreateCommand();
	create.setParent((ShapeDiagram)getHost().getModel());
	create.setChild((Shape)request.getNewObject());
	Rectangle constraint = (Rectangle)getConstraintFor(request);
	create.setConstraint(constraint);
	create.setLabel("Create");  //$NON-NLS-1$
	return create;
}

protected EditPolicy createChildEditPolicy(EditPart child){
	return new ResizableEditPolicy();
}

protected Command getDeleteDependantCommand(Request request) {
	return null;
}

}
