package com.ibm.etools.gef.examples.shapes.model;

import com.ibm.etools.gef.commands.AbstractCommand;

public class AddCommand extends AbstractCommand {

private Shape child;
private ShapeDiagram parent;

public AddCommand() {
	super("Add");  //$NON-NLS-1$
}

public void execute() {
	parent.addChild(child);
}

public String getDescription() {
	String name = child.getClass().getName();
	name = name.substring(name.lastIndexOf(".")+1);  //$NON-NLS-1$
	return "Add " + name;  //$NON-NLS-1$
}

public ShapeDiagram getParent() {
	return parent;
}

public void redo() {
	parent.addChild(child);
}

public void setChild(Shape shape) {
	child = shape;
}

public void setParent(ShapeDiagram diagram) {
	parent = diagram;
}

public void undo() {
	parent.removeChild(child);
}

}
