package com.ibm.etools.gef.examples.shapes.model;

import com.ibm.etools.gef.commands.AbstractCommand;
import com.ibm.etools.draw2d.geometry.Rectangle;

public class CreateCommand extends AbstractCommand {

private Shape child;
private Rectangle rect;
private ShapeDiagram parent;

public CreateCommand() {
	super("Create");  //$NON-NLS-1$
}

public void execute() {
	if (rect != null) {
		child.setLocation(rect.getLocation());
		if (!rect.isEmpty())
			child.setSize(rect.getSize());
	}
	parent.addChild(child);
}

public String getDescription() {
	String name = child.getClass().getName();
	name = name.substring(name.lastIndexOf(".")+1);//$NON-NLS-1$
	return "Create " + name;  //$NON-NLS-1$
}

public ShapeDiagram getParent() {
	return parent;
}

public void redo() {
	if (rect != null) {
		child.setLocation(rect.getLocation());
		child.setSize(rect.getSize());
	}
	parent.addChild(child);
}

public void setChild(Shape shape) {
	child = shape;
}

public void setConstraint(Rectangle r) {
	rect = r;
}

public void setParent(ShapeDiagram diagram) {
	parent = diagram;
}

public void undo() {
	parent.removeChild(child);
}

}
