package com.ibm.etools.gef.examples.shapes.model;

import com.ibm.etools.gef.commands.AbstractCommand;

public class DeleteCommand extends AbstractCommand {

private ShapeDiagram parent;
private Shape child;

public DeleteCommand() {
	super();
}

public DeleteCommand(String label) {
	super(label);
}

public void execute() {
	parent.removeChild(child);
}

public String getDescription() {
	String name = child.getClass().getName();
	name = name.substring(name.lastIndexOf(".")+1);  //$NON-NLS-1$
	return "Delete " + name;  //$NON-NLS-1$
}

public void redo() {
	execute();
}

public void setChild(Shape shape) {
	child = shape;
}

public void setParent(ShapeDiagram diagram) {
	parent = diagram;
}

public void undo() {
	parent.addChild(child);
}

}
