package com.ibm.etools.gef.examples.shapes.model;

import com.ibm.etools.draw2d.geometry.Dimension;
import com.ibm.etools.draw2d.geometry.Point;
import com.ibm.etools.gef.commands.AbstractCommand;
import com.ibm.etools.draw2d.geometry.Rectangle;

public class SetConstraintCommand extends AbstractCommand {

private Point newPos;
private Dimension newSize;
private Point oldPos;
private Dimension oldSize;
private Shape shape;

public void execute() {
	oldSize = shape.getSize();
	oldPos  = shape.getLocation();
	shape.setLocation(newPos);
	shape.setSize(newSize);
}

public String getDescription() {
	String name = shape.getClass().getName();
	name = name.substring(name.lastIndexOf(".")+1);//$NON-NLS-1$
	return "Move " + name;  //$NON-NLS-1$
}

public String getLabel(){
	if (oldSize.equals(newSize))
		return "Move";  //$NON-NLS-1$
	return "Resize";  //$NON-NLS-1$
}

public void redo() {
	shape.setSize(newSize);
	shape.setLocation(newPos);
}

public void setLocation(Rectangle r){
	setLocation(r.getLocation());
	setSize(r.getSize());
}

public void setLocation(Point p) {
	newPos = p;
}

public void setPart(Shape shape) {
	this.shape = shape;
}

public void setSize(Dimension p) {
	newSize = p;
}

public void undo() {
	shape.setSize(oldSize);
	shape.setLocation(oldPos);
}

}
