package com.ibm.etools.gef.examples.shapes.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;

import com.ibm.etools.draw2d.geometry.Dimension;
import com.ibm.etools.draw2d.geometry.Point;

public class Shape 
	implements Serializable
{

public static final String PROP_SIZE     = "size";  //$NON-NLS-1$
public static final String PROP_LOCATION = "location";  //$NON-NLS-1$

transient protected PropertyChangeSupport listeners = new PropertyChangeSupport(this);
private Point location = new Point();
private Dimension size = new Dimension(50, 50);

public void addPropertyChangeListener(PropertyChangeListener listener) {
	listeners.addPropertyChangeListener(listener);
}

protected void firePropertyChange(String prop, Object old, Object newValue) {
	listeners.firePropertyChange(prop, old, newValue);
}

public Point getLocation() {
	return location;
}

public Dimension getSize() {
	return size;
}

public void removePropertyChangeListener(PropertyChangeListener listener) {
	listeners.removePropertyChangeListener(listener);
}

public void setLocation(Point p) {
	setLocation(p.x, p.y);
}

public void setLocation(int x, int y) {
	Point old = new Point(location);
	location.x = x;
	location.y = y;
	firePropertyChange(PROP_LOCATION, old, location);
}

public void setSize(Dimension d) {
	setSize(d.width, d.height);
}

public void setSize(int width, int height) {
	Dimension old = new Dimension(size);
	size.width  = width;
	size.height = height;
	firePropertyChange(PROP_SIZE, old, size);
}

}
