package com.ibm.etools.gef.examples.shapes;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import com.ibm.etools.gef.examples.shapes.model.Ellipse;
import com.ibm.etools.gef.examples.shapes.model.Rectangle;
import com.ibm.etools.gef.examples.shapes.model.RoundedRectangle;
import com.ibm.etools.gef.palette.*;
import com.ibm.etools.gef.requests.CreateRequest;
import com.ibm.etools.gef.tools.CreationTool;

public class ShapePlugin extends AbstractUIPlugin {

public ShapePlugin(IPluginDescriptor desc) {
	super(desc);
}

static private List createCategories() {
	List categories = new ArrayList();
	categories.add(createComponentsCategory());
	return categories;
}

static private PaletteContainer createComponentsCategory() {
	DefaultPaletteCategory category = new DefaultPaletteCategory("Shapes");   //$NON-NLS-1$
	List groups = new ArrayList();
	DefaultPaletteGroup group = new DefaultPaletteGroup("Components Group");  //$NON-NLS-1$
	groups.add(group);
	category.setChildren(groups);

	List entries = new ArrayList();
	
	PaletteToolEntry tool = new DefaultPaletteToolEntry(
			new CreationTool(new CreateRequest.SimpleFactory(Rectangle.class)),
			"Rectangle",  //$NON-NLS-1$
			"Rectangle",  //$NON-NLS-1$
			new Image(null, Rectangle.class.getResourceAsStream("icons/rectangle.gif")), //$NON-NLS-1$
			new Image(null, Rectangle.class.getResourceAsStream("icons/rectangle.gif"))  //$NON-NLS-1$
		);
	entries.add(tool);

	tool = new DefaultPaletteToolEntry(
			new CreationTool(new CreateRequest.SimpleFactory(RoundedRectangle.class)),
			"Rounded Rectangle",  //$NON-NLS-1$
			"Rounded Rectangle",  //$NON-NLS-1$
			new Image(null, RoundedRectangle.class.getResourceAsStream("icons/roundrect.gif")), //$NON-NLS-1$
			new Image(null, RoundedRectangle.class.getResourceAsStream("icons/roundrect.gif"))  //$NON-NLS-1$
		);
	entries.add(tool);

	tool = new DefaultPaletteToolEntry(
			new CreationTool(new CreateRequest.SimpleFactory(Ellipse.class)),
			"Ellipse",  //$NON-NLS-1$
			"Ellipse",  //$NON-NLS-1$
			new Image(null, Ellipse.class.getResourceAsStream("icons/ellipse.gif")), //$NON-NLS-1$
			new Image(null, Ellipse.class.getResourceAsStream("icons/ellipse.gif"))  //$NON-NLS-1$
		);
	entries.add(tool);

	group.setChildren(entries);
	return category;
}

static PaletteRoot createPalette() {
	DefaultPaletteRoot palette = new DefaultPaletteRoot(createCategories());
	return palette;
}

}