package com.ibm.etools.gef.examples.shapes.edit;

import java.util.List;

import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.Figure;
import com.ibm.etools.draw2d.FreeformLayer;
import com.ibm.etools.draw2d.FreeformLayout;
import com.ibm.etools.draw2d.IFigure;
import com.ibm.etools.gef.DragTracker;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.gef.Request;
import com.ibm.etools.gef.editpolicies.RootComponentEditPolicy;
import com.ibm.etools.gef.examples.shapes.model.ShapeDiagram;
import com.ibm.etools.gef.tools.MarqueeDragTracker;

public class ShapeDiagramEditPart extends ShapeEditPart {

protected void createEditPolicies() {
	super.createEditPolicies();
	installEditPolicy(EditPolicy.COMPONENT_ROLE, new RootComponentEditPolicy());
	installEditPolicy(EditPolicy.CONTAINER_ROLE, new ShapeContainerEditPolicy());
	installEditPolicy(EditPolicy.LAYOUT_ROLE, new ShapeXYLayoutEditPolicy());
}

protected IFigure createFigure() {
	Figure fig = new FreeformLayer();
	fig.setLayoutManager(new FreeformLayout());
	fig.setBorder(new MarginBorder(5));
	fig.setOpaque(true);
	return fig;
}

public DragTracker getDragTracker(Request request) {
	return new MarqueeDragTracker();
}

protected List getModelChildren() {
	return getShapeDiagram().getChildren();
}

protected ShapeDiagram getShapeDiagram() {
	return (ShapeDiagram)getModel();
}

}
