package com.ibm.etools.gef.examples.shapes.edit;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import com.ibm.etools.draw2d.ColorConstants;
import com.ibm.etools.draw2d.IFigure;
import com.ibm.etools.draw2d.RectangleFigure;
import com.ibm.etools.draw2d.geometry.Dimension;
import com.ibm.etools.draw2d.geometry.Point;
import com.ibm.etools.draw2d.geometry.Rectangle;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.gef.GraphicalEditPart;
import com.ibm.etools.gef.editparts.AbstractGraphicalEditPart;
import com.ibm.etools.gef.examples.shapes.model.Shape;
import com.ibm.etools.gef.examples.shapes.model.ShapeDiagram;

abstract public class ShapeEditPart 
	extends AbstractGraphicalEditPart 
	implements PropertyChangeListener
{

public void activate() {
	if (isActive())
		return;
	super.activate();
	getShape().addPropertyChangeListener(this);
}

protected void createEditPolicies() {
	installEditPolicy(EditPolicy.COMPONENT_ROLE, new ShapeEditPolicy());
}

protected Shape getShape() {
	return (Shape)getModel();
}

public void propertyChange(PropertyChangeEvent event) {
	String prop = event.getPropertyName();
	if (ShapeDiagram.PROP_CHILDREN.equals(prop))
		refreshChildren();
	else if (Shape.PROP_SIZE.equals(prop) || Shape.PROP_LOCATION.equals(prop))
		refreshVisuals();
}

protected void refreshVisuals() {
	Point location = getShape().getLocation();
	Dimension size = getShape().getSize();
	Rectangle rect = new Rectangle(location, size);
	((GraphicalEditPart)getParent()).setLayoutConstraint(this, getFigure(), rect);
}

}
