package com.ibm.etools.gef.examples.shapes.edit;

import com.ibm.etools.gef.EditPart;
import com.ibm.etools.gef.EditPartFactory;
import com.ibm.etools.gef.examples.shapes.model.*;

public class ShapeEditPartFactory implements EditPartFactory {

public EditPart createEditPart(EditPart context, Object model) {
	EditPart child = null;
	if (model instanceof Rectangle)
		child = new RectangleEditPart();
	else if (model instanceof RoundedRectangle)
		child = new RoundedRectangleEditPart();
	else if (model instanceof Ellipse)
		child = new EllipseEditPart();
	else if (model instanceof ShapeDiagram)
		child = new ShapeDiagramEditPart();
	if (child != null)
		child.setModel(model);
	return child;
}

}
